#include "stdafx.h"
#include "NRadioGroup.h"

//////////////////////////////////////////////////////////////////////////
#include "ScriptletConstant.h"

REGISTER_COMPONENT_CREATOR(SCRIPTLET_RADIOGROUP_NODE, CNRadioGroup);
IMPLEMENT_RTTI(CNRadioGroup, CNControl)

CNRadioGroup::CNRadioGroup()
{
	m_pBtnOld = NULL;
}

CNRadioGroup::~CNRadioGroup()
{
	m_vButton.RemoveAll();
}

//////////////////////////////////////////////////////////////////////////
// PM-552 2007/10/05 11:39:30 
//////////////////////////////////////////////////////////////////////////
void CNRadioGroup::OnPropertyChanged( CPropertyChangeEvent* pPropertyChangedEvent )
{
	if ( IS_KIND_OF(CNButton, pPropertyChangedEvent->m_pSource) == TRUE &&
		_tcscmp(pPropertyChangedEvent->m_szPropertyName, AbstractButtonProperty::Pushed) == 0)
	{
		CNButton* pBtnPerformed = reinterpret_cast<CNButton*>(pPropertyChangedEvent->m_pSource);

		if (pBtnPerformed != m_pBtnOld &&
			m_pBtnOld != NULL)
		{
			m_pBtnOld->SetPushed(FALSE);
			m_pBtnOld->Invalidate();
		}

		m_pBtnOld = pBtnPerformed;
	}
}
//////////////////////////////////////////////////////////////////////////
// PM-552
//////////////////////////////////////////////////////////////////////////

void CNRadioGroup::AddButton( CNButton* pBtn, BOOL bDefaultPushed )
{
	ATLASSERT(IS_KIND_OF(CNButton, pBtn) == TRUE);
	
	if (pBtn->GetStyle() != CAbstractButton::E_BUTTON_STYLE_PUSHED)
	{
		pBtn->SetStyle(CAbstractButton::E_BUTTON_STYLE_PUSHED);
	}

	POSITION pos = m_vButton.Find(pBtn);
	if (pos == NULL)
	{
		pBtn->AddPropertyChangedListener(this);
		pBtn->SetBtnStateBgDg(this);
		m_vButton.AddTail(pBtn);
	}
	if (bDefaultPushed)
	{
		pBtn->SetPushed(TRUE);
		m_pBtnOld = pBtn;
	}
	else if (pBtn->GetPushed() == TRUE)
	{
		m_pBtnOld = pBtn;
	}
}

void CNRadioGroup::RemoveButton( CNButton* pBtn )
{
	ATLASSERT(IS_KIND_OF(CNButton, pBtn) == TRUE);

	POSITION pos = m_vButton.Find(pBtn);
	if (pos != NULL)
	{
		m_vButton.RemoveAt(pos);
		pBtn->RemovePropertyChangedListener(this);
	}
}

BOOL CNRadioGroup::IsChangingAvailable( CAbstractButton* pBtn )
{
	BOOL bResult = (pBtn != m_pBtnOld);
	return bResult;
}